/**************************************************************************
File        : ccamexauthserver.h

Description : definitions for ccamexauthserver. 

Author      : Ranga Satagopan
Created     : 30 Oct 95
Modified    :

***************************************************************************/

#ifndef __CCAMEXAUTHSERVER__
#define __CCAMEXAUTHSERVER__

#include <stddef.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "ccdefs.h"
#include "iso1100.h"
#include "iso1110.h"

typedef CcAmexAuthStatusCodes CcAmexAuthServerStatus ;

/* data */

struct CcAmexAuthServer_t ;
typedef struct CcAmexAuthServer_t* CcAmexAuthServerPtr ;

typedef struct CcAmexAuthServer_t {
	/* attributes */
	/* server (daemon) socket details */
  struct sockaddr_in myAddr ;
  struct sockaddr_in daemon ;
  int    mySockFd ;

	/* public methods */
	Iso1110* (*authorize)(CcAmexAuthServerPtr, Iso1100*, size_t tmOut, CcAmexAuthServerStatus*) ;

	/* private methods */
	CcAmexAuthServerStatus (*send)(CcAmexAuthServerPtr, char*, size_t) ;
	char* (*recv)(CcAmexAuthServerPtr, size_t*, CcAmexAuthServerStatus*) ;
} CcAmexAuthServer ;	

/* public methods */

CcAmexAuthServerPtr initCcAmexAuthServer(CcAmexAuthServerStatus*) ;
void                deleteCcAmexAuthServer(CcAmexAuthServerPtr) ;


#endif /* __CCAMEXAUTHSERVER__ */
