/**************************************************************************
File        : ccdefs.h

Description : definitions of errors, sizes, etc for the amex cc authorization 
              facility.

Author      : Ranga Satagopan
Created     : 30 Oct 95
Modified    :

***************************************************************************/

#ifndef __CCDEFS__
#define __CCDEFS__

#define AMEX_NULL '\0'

/* typedef for return codes */
/* if this is changed, please update ccamexserverutil.c, which has a function
   to return errstring corr. to errnum
*/
typedef enum { AMEX_OK=10,						/* ok */	
               AMEX_UNKNOWN_ADDR,			/* unknown byte ordering convention */
               AMEX_NULL_PTR,					/* null input pointer */
               AMEX_LOW_MEM,          /* malloc error */
               AMEX_TMOUT,						/* request timed out */
               AMEX_NOMATCH,				  /* response had no matching request */
               AMEX_NO_AMEX_HOST_INFO,/* AMEX server details not available */
               AMEX_NO_LOCAL_HOST_INFO,	/* local server details not avlbl */
               AMEX_COMM_FAIL,     		/* error in select */
               AMEX_COMM_AMEX_FAIL,		/* error in commn. with AMEX */
               AMEX_COMM_LOCAL_FAIL,	/* error in interserver commn. */
               AMEX_BAD_REQUEST,			/* wrong request message */
               AMEX_BAD_RESPONSE,			/* wrong response message */
               AMEX_ISO1100_FAIL,			/* ISO 1100 object error */
               AMEX_ISO1110_FAIL,			/* ISO 1110 object error */
               AMEX_OTHER_FAIL
             } CcAmexAuthStatusCodes ;


/* max. number of pending requests */
#define AMEX_INIT_ALLOC (50)
#define AMEX_INCR_ALLOC (20)
#define AMEX_MAX_INCR   (11)

/* length of unique id bit of messages */
#define AMEX_MSGID_LEN (12)

/* data element sizes for internal messages */
#define ISO1100_TMOUT_SZ  (4)
#define ISO1100_UID_SZ    (12)
#define ISO1100_MSG_SZ    (2048)  /* 574 - message string nett */
#define ISO1100_MSGLEN_SZ (3)    /* 3 - size of message length */
#define ISO1100_TOT_SZ    (ISO1100_MSG_SZ + ISO1100_UID_SZ + ISO1100_TMOUT_SZ \
                           + ISO1100_MSGLEN_SZ)

#define ISO1110_RC_SZ     (2)
#define ISO1110_MSG_SZ    (2048)  /* 338 - message string nett */
#define ISO1110_MSGLEN_SZ (ISO1100_MSGLEN_SZ)    /* 3 - size of message length */
#define ISO1110_TOT_SZ    (ISO1110_MSG_SZ + ISO1110_RC_SZ + ISO1110_MSGLEN_SZ)

/* data element sizes for internal messages */
#define ISO1100_AMEX_LEN  (4)
#define ISO1110_AMEX_LEN  (ISO1100_AMEX_LEN)


#endif /* __CCDEFS__ */
