#if !defined(__ISOHASH_H_)
#define __ISOHASH_H_

/**************************************************************************
 * File Name :		isohash.h
 * 
 * Description : 	Declarations for hash functions produced by the
 *						gperf(1) program.
 *
 * Author : 		Ben Lurie
 *
 * See also:
 *		isocountryhash.gperf
 *		isocountryhash.c
 *		isocurrencyhash.gperf
 *		isocurrencyhash.c
 *		isomerchanttypehash.gperf
 *		isomerchanttypehash.c
 *
 * Date Created : 	10/29/95
 *
 **************************************************************************
 */

extern const char* isoMerchantTypeIsValid(const char *str, int len);
extern const IsoCurrencyCode* isoCurrencyLookup (const char *str, 
												 int len);
extern const char* isoCountryIsValid (const char *str, int len);

#endif /* !defined(__ISOHASH_H_) */
