#ifndef MAX_FILE_LEN
#define MAX_FILE_LEN 128
#endif

#ifndef BUFFER_SIZE
#define BUFFER_SIZE 256
#endif

#ifndef USERID_LEN
#define USERID_LEN 11  /* maximum MIT ECAT username is 10 + \0 */
#endif

#ifndef QUANTITY_LEN
#define QUANTITY_LEN 6  /* max of 99999 of item to buy and/or cylinders to return */
#endif

#ifndef ITEM_CODE_LEN
#define ITEM_CODE_LEN 16  /* 3 char supplier code + 12 char sup num + \0 */
#endif

#ifndef PRICE_LEN
#define PRICE_LEN 9  /* no price > $500.00 allowed, but 8 chars in file */
#endif

#ifndef UNIT_LEN
#define UNIT_LEN 6  /* 5 char field + \0 */
#endif

#ifndef ORDER_NUM_LEN
#define ORDER_NUM_LEN 7  /* max of 999999 for unique order number value + \0 */
#endif

#ifndef DATE_TIME_LEN
#define DATE_TIME_LEN 17  /* YYYYMMDD = date stamp, HHMMSSHD = time stamp + \0 */
#endif

#ifndef ORDER_TOTAL_LEN
#define ORDER_TOTAL_LEN 14  /* 9999999999.99 = max order total + \0 */
#endif

#ifndef ORDER_BUFF
#define ORDER_BUFF 600
#endif

#ifndef RECORD_TYPE_LEN
#define RECORD_TYPE_LEN 2  /* order record types = 2,4,6,8 */
#endif

#ifndef HEADER_RECTYPE
#define HEADER_RECTYPE "2"  /* order file header record type */
#endif

#ifndef COMMENT_RECTYPE
#define COMMENT_RECTYPE "4"  /* order file comment record type */
#endif

#ifndef DETAIL_RECTYPE
#define DETAIL_RECTYPE "6"  /* order file detail record type */
#endif

#ifndef TRAILER_RECTYPE
#define TRAILER_RECTYPE "8"  /* order file trailer record type */
#endif

#ifndef COMMENTS_LEN
#define COMMENTS_LEN 513  /* max order comments = 512 + \0 */
#endif

#ifndef PERCENT_LEN
#define PERCENT_LEN 4  /* max 100% of order total charged to one account */
#endif

#ifndef PHONE_LEN
#define PHONE_LEN 17  /* requisitioner phone number length max = 16 + \0 */
#endif

#ifndef NAME_LEN
#define NAME_LEN 33  /* requisitioner name length max = 32 + \0 */
#endif

#ifndef ADDRESS_LEN
#define ADDRESS_LEN 49  /* requisitioner address length max = 48 + \0 */
#endif

#ifndef STATE_LEN
#define STATE_LEN 3  /* requisitioner state length max = 2 + \0 */
#endif

#ifndef ZIP_LEN
#define ZIP_LEN 11  /* requisitioner zip code length max = 10 + \0 */
#endif

#ifndef BOC_ACCT_LEN
#define BOC_ACCT_LEN 8  /* max size for BOC customer account number = 7 + \0 */
#endif

#ifndef ACCOUNT_LEN
#define ACCOUNT_LEN 21  /* account number = 15 char + \0 */
#endif

#ifndef MAX_ACCOUNTS
#define MAX_ACCOUNTS 3  /* can split up order total to be charged to up to 3 accounts */
#endif

#ifndef PERCENT_SIGN
#define PERCENT_SIGN "%"
#endif

#ifndef CC_NUM_LEN
#define CC_NUM_LEN 16  /* AmEx credit card number length = 15 + \0 */
#endif

#ifndef CC_EXP_LEN
#define CC_EXP_LEN 5  /* AmEx credit card expiration date length = 4 + \0 */
#endif

#ifndef ACTION_CODE_LEN
#define ACTION_CODE_LEN 4
#endif

#ifndef APPROVAL_CODE_LEN
#define APPROVAL_CODE_LEN 6
#endif

#ifndef MAX_DIFF_ITEMS
#define MAX_DIFF_ITEMS 128
#endif

#ifndef MERCHANT_TYPE
#define MERCHANT_TYPE 5999
#endif

#ifndef COUNTRY 
#define COUNTRY "840"
#endif

#ifndef POS_DATA
#define POS_DATA "160040100130"
#endif

#ifndef CARD_ACCEPTOR_ID
#define CARD_ACCEPTOR_ID "2204717185"
#endif

#ifndef ACCEPTOR_NAME
#define ACCEPTOR_NAME "BOC"
#endif

#ifndef ACCEPTOR_ZIP
#define ACCEPTOR_ZIP "11111"
#endif

#ifndef ACCEPTOR_REGION
#define ACCEPTOR_REGION "00"
#endif

#ifndef ACCEPTOR_COUNTRY
#define ACCEPTOR_COUNTRY "840"
#endif

#ifndef CURRENCY_CODE
#define CURRENCY_CODE "840"
#endif

#ifndef SECURITY_INFO
#define SECURITY_INFO "abcdefg"
#endif

#ifndef TCPAUTH_DAEMON_HOSTIP
#define TCPAUTH_DAEMON_HOSTIP "204.146.47.164"
#endif

#ifndef TCPAUTH_DAEMON_HOSTNAME
#define TCPAUTH_DAEMON_HOSTNAME "boc.hosting.ibm.com"
#endif

#ifndef TCPAUTH_DAEMON_PORTNUM
#define TCPAUTH_DAEMON_PORTNUM "14025"
#endif

struct CardAcceptLoc {
   unsigned char  name[41];    /* lengths of these fields ???? AMEX provides */
   unsigned char  zip[11];
   unsigned char  region[11];
   unsigned char  country[4];
};

typedef struct acct {
  char         number[ACCOUNT_LEN];
  char         percent[PERCENT_LEN];
  struct acct  *next_acct;
} Acct, *p_acct;

typedef struct item {
  char         code[ITEM_CODE_LEN];
  char         orders[QUANTITY_LEN];
  char         returns[QUANTITY_LEN];
  char         price[PRICE_LEN];
  struct item  *next_item;
} Item, *p_item;
